POJ2126——Prime Path(BFS)

Prime Path


Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
    1033
    1733
    3733
    3739
    3779
    8779
    8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

题目大意:

    给定两个4位素数a和b,输出从a变到b需要几次。变换规则如下:

    变换的过程要保证 每次变换出来的数都是一四位素数,而且当前这步的变换所得的素数与前一步得到的素数只能有一个位不同。

    求从a到b最少需要的变换次数。无法变换则输出Impossible.

解题思路:

    简单的BFS,注意千位不能为0即可。

Code:

 1 /*************************************************************************
 2     > File Name: poj3126.cpp
 3     > Author: Enumz
 4     > Mail: 369372123@qq.com 
 5     > Created Time: 2014年10月20日 星期一 16时46分57秒
 6  ************************************************************************/
 7 
 8 #include<iostream>
 9 #include<cstdio>
10 #include<cstdlib>
11 #include<string>
12 #include<cstring>
13 #include<list>
14 #include<queue>
15 #include<stack>
16 #include<map>
17 #include<set>
18 #include<algorithm>
19 #define MAXN 30000
20 using namespace std;
21 queue <int> q;
22 int dis[MAXN];
23 bool vis[MAXN],a[MAXN];
24 void init_prime()
25 {
26     a[0]=a[1]=1;
27     for (int i=2;i<=9999;i++)
28         if (!a[i])
29             for (int j=2*i;j<=9999;j+=i)
30                 a[j]=1;
31 }
32 int bfs(int k1,int k2)
33 {
34     memset(dis,0,sizeof(dis));
35     memset(vis,0,sizeof(vis));
36     while (!q.empty()) q.pop();
37     q.push(k1);
38     dis[k1]=0,vis[k1]=1;
39     while (!q.empty())
40     {
41         int tmp=q.front();
42         q.pop();
43         if (tmp==k2) return dis[tmp];
44         if (tmp>9999||tmp<1000) continue;
45         int tmp1=tmp-tmp%10;
46         int tmp2=tmp-tmp%100+tmp%10;
47         int tmp3=tmp-tmp%1000+tmp%100;
48         int tmp4=tmp%1000;
49         for (int i=1;i<=9;i+=2)
50             if (!a[tmp1+i]&&!vis[tmp1+i])
51             {
52                 dis[tmp1+i]=dis[tmp]+1;
53                 q.push(tmp1+i);
54                 vis[tmp1+i]=1;
55             }
56         for (int i=0;i<=90;i+=10)
57             if (!a[tmp2+i]&&!vis[tmp2+i])
58             {
59                 dis[tmp2+i]=dis[tmp]+1;
60                 q.push(tmp2+i);
61                 vis[tmp2+i]=1;
62             }
63         for (int i=0;i<=900;i+=100)
64             if (!a[tmp3+i]&&!vis[tmp3+i])
65             {
66                 dis[tmp3+i]=dis[tmp]+1;
67                 q.push(tmp3+i);
68                 vis[tmp3+i]=1;
69             }
70         for (int i=1000;i<=9000;i+=1000)
71             if (!a[tmp4+i]&&!vis[tmp4+i])
72             {
73                 dis[tmp4+i]=dis[tmp]+1;
74                 q.push(tmp4+i);
75                 vis[tmp4+i]=1;
76             }
77     }
78     
79     return -1;
80 }
81 int main()
82 {
83     init_prime();
84     int T;
85     cin>>T;
86     while (T--)
87     {
88         int k1,k2;
89         cin>>k1>>k2;
90         int ret=bfs(k1,k2);
91         if (ret!=-1) 
92             printf("%d\n",ret);
93         else 
94             printf("Impossible\n");
95     }
96     return 0;
97 }

 

转载于:https://www.cnblogs.com/Enumz/p/4094676.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值